﻿using Windows.Storage;
using Windows.UI.Xaml.Controls;

namespace Zustandsspeicherung_1
{
    public sealed partial class MainPage : Page, ISession
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        public void Save()
        {
            ApplicationData.Current.LocalSettings.Values["Lattitude"] = lattitude.Text;
            ApplicationData.Current.LocalSettings.Values["Longitude"] = longitude.Text;

            var address = new Address
            {
                Country = country.Text,
                PostCode = postCode.Text,
                Town = town.Text,
                Street = street.Text
            };
            Session.Save(address);
        }

        public async void Restore()
        {
            lattitude.Text = (string)ApplicationData.Current.LocalSettings.Values["Lattitude"];
            longitude.Text = (string)ApplicationData.Current.LocalSettings.Values["Longitude"];

            var address = await Session.Restore(typeof(Address)) as Address;

            country.Text = address.Country;
            postCode.Text = address.PostCode;
            town.Text = address.Town;
            street.Text = address.Street;
        }
    }
}
