﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Runtime.Serialization;
using System.Threading.Tasks;
using Windows.Storage;

namespace Zustandsspeicherung_1
{
    public interface ISession
    {
        void Save();
        void Restore();
    }

    static public class Session
    {
        static List<ISession> sessions = new List<ISession>();

        static public void Register(ISession session)
        {
            sessions.Add(session);
        }

        static public void UnRegister(ISession session)
        {
            sessions.Remove(session);
        }
        static public void Save()
        {
            foreach (var session in sessions)
                session.Save();
        }

        static public void Restore()
        {
            foreach (var session in sessions)
                session.Restore();
        }

        static public async void Save(object dataObject)
        {
            var file = await ApplicationData.Current.LocalFolder.CreateFileAsync("dataObject.xml", CreationCollisionOption.ReplaceExisting);

            using (Stream stream = await file.OpenStreamForWriteAsync())
            {
                var serializer = new DataContractSerializer(dataObject.GetType());

                serializer.WriteObject(stream, dataObject);
            }
        }

        static public async Task<object> Restore(Type typeObject)
        {
            using (var stream = await ApplicationData.Current.LocalFolder.OpenStreamForReadAsync("dataObject.xml"))
            {
                var serializer = new DataContractSerializer(typeObject);

                return serializer.ReadObject(stream);
            }
        }
    }
}
