﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Windows.UI.Xaml.Controls;

namespace Binding_5
{
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();

            var personen = new ObservableCollection<Person>();

            personen.Add(new Person()
            {
                Vorname = "Hans",
                Nachname = "Muster",
                Geburtsdatum = new DateTime(1990, 01, 01)
            });
            personen.Add(new Person()
            {
                Vorname = "Max",
                Nachname = "Meier",
                Geburtsdatum = new DateTime(1995, 10, 18)
            });
            personen.Add(new Person()
            {
                Vorname = "Berta",
                Nachname = "Lustig",
                Geburtsdatum = new DateTime(1982, 12, 22)
            });

            personenListe.DataContext = personen;

        }

        private void Button_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            if (personenListe.SelectedIndex < 0)
                return;

            var personen = personenListe.DataContext as ObservableCollection<Person>;
            personen.RemoveAt(personenListe.SelectedIndex);
        }
    }

    public class Person
    {
        public string Vorname { get; set; }
        public string Nachname { get; set; }
        public DateTime Geburtsdatum { get; set; }

        public override string ToString()
        {
            return string.Format("Vorname:\t\t{0}\nNachname:\t\t{1}" +
                                 "\nGeburtsdatum:\t{2}",
                                 Vorname, Nachname, Geburtsdatum);
        }
    }
}
