﻿using System;
using System.Globalization;
using Windows.UI.Xaml.Data;

namespace Binding_6
{
    public class BirthdayConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            var date = (DateTime)value;

            CultureInfo cultureInfo;

            if (string.IsNullOrEmpty(language))
                cultureInfo = CultureInfo.CurrentCulture;
            else
                cultureInfo = new CultureInfo(language);

            var birthday = $"{date:d}";

            return birthday;
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            CultureInfo cultureInfo;

            if (string.IsNullOrEmpty(language))
                cultureInfo = CultureInfo.CurrentCulture;
            else
                cultureInfo = new CultureInfo(language);

            return DateTime.Parse((string)value, cultureInfo);
        }

    }
}
