﻿using System;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace Binding_7
{
    public sealed partial class MainPage : Page
    {
        public Person Person { get; }

        public MainPage()
        {
            this.InitializeComponent();

            Person = new Person()
            {
                Vorname = "Hans",
                Nachname = "Muster",
                Geburtsdatum = new DateTime(1990, 01, 01)
            };
        }

        private void Change_Click(object sender, RoutedEventArgs e)
        {
            Person.Vorname = Person.Vorname.ToUpper();
            Person.Nachname = Person.Nachname.ToUpper();
        }
    }

    public class Person : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        private void setProperty([CallerMemberName] string propertyName = null)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        public string Vorname
        {
            get { return vorname; }
            set { vorname = value; setProperty(); }
        }

        public string Nachname
        {
            get { return nachname; }
            set { nachname = value; setProperty(); }
        }

        public DateTime Geburtsdatum
        {
            get { return geburtsdatum; }
            set { geburtsdatum = value; setProperty(); }
        }

        private string vorname;
        private string nachname;
        private DateTime geburtsdatum;
    }


}
