﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Core;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.UI.Xaml.Shapes;

// Die Vorlage "Leere Seite" ist unter http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409 dokumentiert.

namespace Controls_6
{
    public sealed partial class MainPage : Page
    {
        CoreCursor _cursor;
        double _x1, _x2, _y1, _y2;
        Shape _shape;

        public MainPage()
        {
            this.InitializeComponent();
            _cursor = Window.Current.CoreWindow.PointerCursor;
        }

        private void Canvas_PointerPressed(object sender, PointerRoutedEventArgs e)
        {
            Window.Current.CoreWindow.PointerCursor =
           new CoreCursor(CoreCursorType.Cross, 1);

            _x1 = e.GetCurrentPoint(canvas).Position.X;
            _y1 = e.GetCurrentPoint(canvas).Position.Y;
            _x2 = _x1;
            _y2 = _y1;

            _shape = (Shape)new Ellipse();

            _shape.Width = _x2 - _x1;
            _shape.Height = _y2 - _y1;
            _shape.StrokeThickness = 3;
            _shape.Stroke = new SolidColorBrush(Windows.UI.Colors.Blue);
            _shape.Fill = new SolidColorBrush(Windows.UI.Colors.Red);

            canvas.Children.Add(_shape);
        }

        private void Canvas_PointerMoved(object sender, PointerRoutedEventArgs e)
        {
            if (_shape == null)
                return;

            _x2 = e.GetCurrentPoint(canvas).Position.X;
            _y2 = e.GetCurrentPoint(canvas).Position.Y;

            Canvas.SetLeft(_shape, (_x2 > _x1 ? _x1 : _x2));
            Canvas.SetTop(_shape, (_y2 > _y1 ? _y1 : _y2));

            _shape.Width = Math.Abs(_x2 - _x1);
            _shape.Height = Math.Abs(_y2 - _y1);
        }

        private void Canvas_PointerReleased(object sender, PointerRoutedEventArgs e)
        {
            Window.Current.CoreWindow.PointerCursor = _cursor;
            _shape = null;
        }
    }
}
