﻿using System;
using System.Collections.Generic;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.Storage.Streams;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;

namespace Controls_14
{
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            stretchMode.ItemsSource = Enum.GetNames(typeof(Stretch));
            stretchMode.SelectedIndex = 0;
        }

        private void stretchMode_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var stretch = (Stretch)Enum.Parse(typeof(Stretch), (string)stretchMode.SelectedValue);
            image.Stretch = stretch;
        }

        private async void OpenFile_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            var openPicker = new FileOpenPicker();

            openPicker.SuggestedStartLocation =
                                 PickerLocationId.PicturesLibrary;
            openPicker.ViewMode = PickerViewMode.Thumbnail;

            foreach (var extension in new string[] { ".bmp", ".png", ".jpg", ".jpeg" })
            {
                openPicker.FileTypeFilter.Add(extension);
            }

            StorageFile file = await openPicker.PickSingleFileAsync();

            if (file != null)
            {
                using (IRandomAccessStream stream = await file.OpenAsync(FileAccessMode.Read))
                {
                    var bitmap = new BitmapImage();
                    bitmap.SetSource(stream);
                    image.Source = bitmap;
                }
            }
        }
    }
}
