﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Documents;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// Die Vorlage "Leere Seite" ist unter http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409 dokumentiert.

namespace Controls_16
{
    public sealed partial class MainPage : Page
    {
        private class Method
        {
            public MethodInfo MethodInfo { get; set; }
            public Type[] ParameterTypes { get; set; }
        }

        public MainPage()
        {
            this.InitializeComponent();

            IEnumerable<PropertyInfo> list = typeof(Typography).GetTypeInfo().DeclaredProperties;

            foreach (PropertyInfo prop in list)
            {
                var item = new ComboBoxItem();
                item.Content = prop.Name.Replace("Property", "");

                typo.Items.Add(item);
            }

            typo.SelectedIndex = 0;
        }

        private void typo_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var item = (ComboBoxItem)typo.SelectedValue;

            Method method;

            if (item.Tag == null)
            {
                var property = item.Content;

                IEnumerable<MethodInfo> list =
                   typeof(Typography).GetRuntimeMethods()
                                     .Where(m => m.Name == "Set" + property);

                MethodInfo methodInfo = list.First<MethodInfo>();

                method = new Method();
                method.MethodInfo = methodInfo;

                item.Tag = method;
            }
            else
                method = (Method)item.Tag;
            param.Items.Clear();

            ParameterInfo[] pars = method.MethodInfo.GetParameters();
            Type[] types = new Type[2];

            types[0] = pars[0].ParameterType;
            types[1] = pars[1].ParameterType;

            method.ParameterTypes = types;

            if (types[1] == typeof(bool))
            {
                param.Items.Add(bool.TrueString);
                param.Items.Add(bool.FalseString);
            }
            else if (types[1] == typeof(int))
            {
                param.Items.Add(0);
                param.Items.Add(1);
                param.Items.Add(2);
                param.Items.Add(3);
            }
            else
            {
                string[] enums = Enum.GetNames(types[1]);

                foreach (string name in enums)
                    param.Items.Add(name);
            }

            param.SelectedIndex = 0;
        }

        private void param_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (param.SelectedIndex == -1)
                return;

            var item = (ComboBoxItem)typo.SelectedItem;
            var method = (Method)item.Tag;

            object value = param.SelectedItem.ToString();

            if (method.ParameterTypes[1] == typeof(bool))
            {
                value = (bool)bool.Parse((string)value);
            }
            else if (method.ParameterTypes[1] == typeof(int))
            {
                value = (int)int.Parse((string)value);
            }
            else
            {
                value = Enum.Parse(method.ParameterTypes[1],
                                  (string)value);
            }

            Run run = new Run();
            run.Text = input.Text;

            method.MethodInfo.Invoke(run, new object[] { run, value });

            text.Inlines.Clear();
            text.Inlines.Add(run);
        }
    }
}
