﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Windows.Storage;
using Windows.Storage.FileProperties;
using Windows.UI.Xaml.Media.Imaging;

namespace Controls_17
{
    public class Image
    {
        public string Name { get; set; }
        public BitmapImage BitmapImage { get; set; }
        public DateTimeOffset DateCreated { get; set; }
        public string Path { get; set; }
        public string FileType { get; set; }
    }

    public class ImageList : ObservableCollection<Image>
    {
        public ImageList()
        {
            update();
        }

        private async void update()
        {
            StorageFolder pictureFolder = KnownFolders.PicturesLibrary;
            IReadOnlyList<StorageFile> fileList = await pictureFolder.GetFilesAsync();

            foreach (StorageFile f in fileList)
            {
                StorageItemThumbnail thumbnail = await
                   f.GetThumbnailAsync(ThumbnailMode.PicturesView, 200,
                                       ThumbnailOptions.ResizeThumbnail);

                var image = new BitmapImage();
                image.SetSource(thumbnail);

                Add(new Image()
                {
                    BitmapImage = image,
                    Name = f.Name,
                    DateCreated = f.DateCreated,
                    FileType = f.DisplayType,
                    Path = f.Path
                });
            }
        }
    }
}
