﻿using System;
using Windows.Storage;
using Windows.Storage.Streams;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Media.Imaging;
using Windows.UI.Xaml;
using System.Threading.Tasks;

namespace Controls_21
{
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        public async void ListView_ItemClick(object sender, ItemClickEventArgs e)
        {
            progress.Visibility = Visibility.Visible;
            progress.IsActive = true;

            popup.IsOpen = true;
            popup.VerticalOffset = 20 + scrollviewer.VerticalOffset;

            var item = e.ClickedItem as Image;
            var image = new BitmapImage();

            StorageFile f = await StorageFile.GetFileFromPathAsync(item.Path);

            using (IRandomAccessStream fileStream = await f.OpenAsync(FileAccessMode.Read))
            {
                image.SetSource(fileStream);

                fullImage.Width = this.ActualWidth - 100;
                fullImage.Height = this.ActualHeight - 100;
                fullImage.Source = image;
            }

            var properties = await f.Properties.GetImagePropertiesAsync();
            details.Text = $"aufgenommen am {properties.DateTaken}, Breite: {properties.Latitude}, Länge: {properties.Longitude}";

            await Task.Delay(TimeSpan.FromSeconds(1));
            progress.Visibility = Visibility.Collapsed;
            progress.IsActive = false;
        }
    }
}
